#!/usr/bin/env python3
#
# Copyright (c) 2024 Stormux
# Copyright (c) 2010-2012 The Orca Team
# Copyright (c) 2012 Igalia, S.L.
# Copyright (c) 2005-2010 Sun Microsystems Inc.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., Franklin Street, Fifth Floor,
# Boston MA  02110-1301 USA.
#
# Fork of Orca Screen Reader (GNOME)
# Original source: https://gitlab.gnome.org/GNOME/orca

"""Test of Where am I for links."""

from macaroon.playback import *
import utils

sequence = MacroSequence()

#sequence.append(WaitForDocLoad())
sequence.append(PauseAction(5000))
sequence.append(KeyComboAction("<Shift>Tab"))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyPressAction(0, None, "KP_Insert"))
sequence.append(KeyComboAction("KP_Enter"))
sequence.append(KeyReleaseAction(0, None, "KP_Insert"))
sequence.append(utils.AssertPresentationAction(
    "1. Title bar",
    ["BRAILLE LINE:  'Product summary'",
     "     VISIBLE:  'Product summary', cursor=1",
     "BRAILLE LINE:  'GNOME Bug Tracking System - Firefox Nightly'",
     "     VISIBLE:  'GNOME Bug Tracking System - Fire', cursor=0",
     "SPEECH OUTPUT: 'GNOME Bug Tracking System - Firefox Nightly'"]))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("KP_Enter"))
sequence.append(utils.AssertPresentationAction(
    "2. Where Am I on Product summary link", 
    ["BRAILLE LINE:  'Product summary'",
     "     VISIBLE:  'Product summary', cursor=1",
     "BRAILLE LINE:  'Product summary'",
     "     VISIBLE:  'Product summary', cursor=1",
     "SPEECH OUTPUT: 'http link Product summary.'",
     "SPEECH OUTPUT: 'different site.'"]))

sequence.append(PauseAction(5000))
sequence.append(KeyComboAction("<Control>Home"))
sequence.append(KeyComboAction("Tab"))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyPressAction(0, None, "KP_Insert"))
sequence.append(KeyComboAction("KP_Enter"))
sequence.append(KeyReleaseAction(0, None, "KP_Insert"))
sequence.append(utils.AssertPresentationAction(
    "3. Title bar",
    ["BRAILLE LINE:  'GNOME Bug Tracking System - Firefox Nightly'",
     "     VISIBLE:  'GNOME Bug Tracking System - Fire', cursor=0",
     "SPEECH OUTPUT: 'GNOME Bug Tracking System - Firefox Nightly'"]))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("KP_Enter"))
sequence.append(utils.AssertPresentationAction(
    "4. Where Am I on what should be the New bug link",
    ["BRAILLE LINE:  'New bug'",
     "     VISIBLE:  'New bug', cursor=1",
     "BRAILLE LINE:  'New bug'",
     "     VISIBLE:  'New bug', cursor=1",
     "SPEECH OUTPUT: 'http link New bug.'",
     "SPEECH OUTPUT: 'different site.'"]))

sequence.append(utils.AssertionSummaryAction())
sequence.start()
